# 64-bit, SSE 4.2, Linux, GNU Assembly
# code by gynvael.coldwind//vx
# http://gynvael.coldwind.pl/
.intel_syntax noprefix

.text
.globl find_range
.type  find_range, @function
find_range:
  push rbp
  mov  rbp, rsp

  # args are in:
  # RDI - pointer to out table
  # RSI - pointer to in table
  # RDX - pointer to in range

  next_data_packet:
    mov r8, rdx
    movdqu xmm1, [rsi]
    pxor   xmm3, xmm3

    next_mask:
      movdqu xmm2, [r8]

      # unsigned byte, range, pos. polarity, byte mask
      pcmpistrm xmm2, xmm1, (0 | (1 << 2) | (0 << 4) | (1 << 6))
      por xmm3, xmm0
      
      # ZF set == end of table
      # SF set == end of range

      js end_of_mask
      add r8, 0x10
      jmp next_mask

  end_of_mask:
    movdqu [rdi], xmm3
    jz end_of_table
    add rsi, 0x10
    add rdi, 0x10
    jmp next_data_packet 
      
end_of_table:
  xor eax, eax
  leave
  ret

